import socket, hashlib, struct, string

def get_number (value):
    digits = ""
    spaces = 0
    for char in value:
        if char in string.digits:
            digits += char
        elif char == " ":
            spaces += 1
    return int(digits) / spaces

def calculate_checksum (request):
    for line in request.splitlines():
        if line.startswith("Sec-WebSocket-Key1:"):
            key1 = get_number(line[20:])
        elif line.startswith("Sec-WebSocket-Key2:"):
            key2 = get_number(line[20:])
    key3 = request.splitlines()[-1].strip()
    key = struct.pack(">II", key1, key2) + key3
    return hashlib.md5(key).digest()

sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
sock.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, True)
sock.bind(("localhost", 5000))
sock.listen(1)

while True:
    client, address = sock.accept()
    request = client.recv(256)
    checksum = calculate_checksum(request)  
    client.send("HTTP/1.1 101 Web Socket Protocol Handshake\r\n"
                "Upgrade: WebSocket\r\n"
                "Connection: Upgrade\r\n"
                "Sec-WebSocket-Origin: null\r\n"
                "Sec-WebSocket-Location: ws://localhost:5000/\r\n"
                "\r\n")
    client.send(checksum)
    client.send(10 * '\xff')
